<template>
  <div>
    <el-tabs v-model="activeTab" type="border-card" tab-position="left">
      <el-tab-pane
        v-for="(locale, name) in locales"
        :key="locale"
        :label="`${name}`.toUpperCase()"
        :name="locale"
      >
        <el-table-draggable @drop="onDrop">
          <el-table
            :data="result ? result.menu : []"
            :default-sort="{ order: 'ascending' }"
          >
            <el-table-column label="Name" sortable prop="id">
              <template slot-scope="scope">
                {{ getName(scope.row) }}
              </template>
            </el-table-column>
            <el-table-column label="URL" sortable prop="url" />
            <el-table-column label="External" sortable prop="external">
              <template slot-scope="scope">
                <el-tag
                  :type="scope.row.external ? 'success' : 'info'"
                  size="mini"
                >
                  {{ scope.row.external ? 'yes' : 'no' }}
                </el-tag>
              </template>
            </el-table-column>
            <el-table-column label="Order" sortable prop="order" />

            <el-table-column align="right">
              <template #header>
                <el-button type="primary" @click="dialogVisible = true">
                  Add
                </el-button>
              </template>
              <template slot-scope="scope">
                <el-button
                  type="primary"
                  plain=""
                  size="small"
                  @click="editMenuItem(scope.row)"
                >
                  Edit
                </el-button>

                <el-button
                  type="danger"
                  plain=""
                  size="small"
                  @click="deleteMenuItem(scope.row)"
                >
                  Delete
                </el-button>
              </template>
            </el-table-column>
          </el-table>
        </el-table-draggable>
      </el-tab-pane>
    </el-tabs>

    <el-dialog
      :title="newItem.id ? 'Edit menu item' : 'Add menu item'"
      :visible.sync="dialogVisible"
      width="450px"
    >
      <el-form :model="newItem" @submit.native.prevent>
        <el-tabs type="card" v-model="activeTab">
          <el-tab-pane
            v-for="(locale, name) in locales"
            :key="locale"
            :label="`${name}`.toUpperCase()"
            :name="locale"
          >
            <el-form-item label="Name">
              <el-input
                v-model="newItem.localizations[locale]"
                placeholder="Name"
              ></el-input>
            </el-form-item>
          </el-tab-pane>
        </el-tabs>
        <el-form-item label="URL">
          <el-input v-model="newItem.url" placeholder="URL"></el-input>
        </el-form-item>

        <el-checkbox v-model="newItem.external">External</el-checkbox>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">Cancel</el-button>
        <el-button type="primary" @click="addMenuItem" :disabled="!newItem.url">
          {{ newItem.id ? 'Save' : 'Add' }}
        </el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, watch } from '@nuxtjs/composition-api'
import {
  Menu_Type_Enum,
  Locales_Enum,
  MenuItemWithLocalizationFragment,
  Localizations_Constraint,
  Localizations_Update_Column
} from '@/sdk/types'

import { pick } from 'lodash'
import {
  useAdminMenuItemsQuery,
  useAdminUpdateOrderMenuItemsMutation,
  useAdminDeleteMenuItemMutation,
  useAdminAddMenuItemMutation
} from '~/sdk/hooks'

type Item = {
  id: string | null
  url: string
  external: boolean
  localizations: { [key in Locales_Enum]?: string }
}

export default defineComponent<{
  type: Menu_Type_Enum
}>({
  name: 'AdminMenuForm',
  props: ['type'],
  components: {
    // @ts-ignore
    ElTableDraggable: () => import('element-ui-el-table-draggable')
  },
  setup({ type }, { root }) {
    const { result, refetch } = useAdminMenuItemsQuery({
      type
    })

    const dialogVisible = ref(false)
    const activeTab = ref<Locales_Enum>(Locales_Enum.En)
    const newItem = ref<Item>(createItem())

    function createItem(): Item {
      const localizations: { [key in Locales_Enum]?: string } = {}
      Object.entries(Locales_Enum).forEach(e => {
        localizations[e[1]] = ''
      })

      const item: Item = {
        id: null,
        url: '',
        external: false,
        localizations
      }

      return item
    }

    function getName(item: MenuItemWithLocalizationFragment): string {
      return (
        item.localizations.find(l => l.locale === activeTab.value)?.value ||
        item.localizations.find(l => l.locale === Locales_Enum.En)?.value ||
        '-'
      )
    }

    const { mutate: updateOrderMutate } = useAdminUpdateOrderMenuItemsMutation({
      errorPolicy: 'all',
      context: {
        headers: {
          'x-hasura-role': 'administrator'
        }
      }
    })

    async function onDrop() {
      if (!result.value) return
      await updateOrderMutate({
        objects: result.value.menu.map((m, order) => ({
          ...pick(m, ['id', 'url', 'external']),
          order,
          type
        }))
      })
      await refetch()
    }

    const { mutate: deleteMutate } = useAdminDeleteMenuItemMutation({
      errorPolicy: 'all',
      context: {
        headers: {
          'x-hasura-role': 'administrator'
        }
      }
    })
    function deleteMenuItem(item: MenuItemWithLocalizationFragment) {
      root.$confirm(`Delete menu item ${getName(item)}?`, {
        type: 'warning',
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        center: true,
        async callback(action) {
          if (action === 'confirm') await deleteMutate({ id: item.id })
          await refetch()
        }
      })
    }

    function editMenuItem(item: MenuItemWithLocalizationFragment) {
      const editMenuItem = createItem()
      editMenuItem.id = item.id
      editMenuItem.external = item.external
      editMenuItem.url = item.url
      item.localizations.forEach(l => {
        editMenuItem.localizations[l.locale] = l.value
      })
      newItem.value = editMenuItem
      dialogVisible.value = true
    }

    const { mutate } = useAdminAddMenuItemMutation({
      errorPolicy: 'all',
      context: {
        headers: {
          'x-hasura-role': 'administrator'
        }
      }
    })
    async function addMenuItem() {
      await mutate({
        item: {
          id: newItem.value.id || undefined,
          type,
          url: newItem.value.url,
          external: newItem.value.external,
          order: result.value?.menu.length || 0,
          localizations: {
            data: [
              ...Object.entries(newItem.value.localizations).map(e => ({
                locale: e[0] as Locales_Enum,
                value: e[1]
              }))
            ],
            on_conflict: {
              constraint: Localizations_Constraint.LocalizationsMenuIdLocaleKey,
              update_columns: [Localizations_Update_Column.Value]
            }
          }
        }
      })
      await refetch()
      dialogVisible.value = false
    }

    watch(dialogVisible, value => {
      if (!value) newItem.value = createItem()
    })

    return {
      result,
      onDrop,
      addMenuItem,
      dialogVisible,
      activeTab,
      getName,
      newItem,
      deleteMenuItem,
      editMenuItem,
      locales: {
        ...Locales_Enum
      }
    }
  }
})
</script>
